<?php
/**
 * Created by PhpStorm.
 * Script Name: Index.php
 * Create: 2020/9/6 下午10:03
 * Description:
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace app\admin\controller;

use think\facade\Cache;

class Index extends Base
{
    public function initialize()
    {
        if(request()->action() == 'index'){
            $this->layout = false;
        }
        parent::initialize(); // TODO: Change the autogenerated stub
    }

    public function index(){
        return $this->show();
    }

    /**
     * @return mixed
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function welcome(){
        return $this->show();
    }

    /**
     * 清除缓存
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function clearCache(){
        Cache::clear();
        $this->success('清理成功');
    }

    /**
     * 获取初始化数据
     * @return \think\response\Json
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function getSystemInit(){
        $homeInfo = [
            'title' => '首页',
            'href'  => '/admin/index/welcome',
        ];
        $logoInfo = [
            'title' => config('system.site.company_title'),
            'href' => '/admin/index/index'
            //'image' => '',
        ];
        $menuInfo = $this->getMenuList();
        $systemInit = [
            'homeInfo' => $homeInfo,
            'logoInfo' => $logoInfo,
            'menuInfo' => $menuInfo,
        ];
        return json($systemInit);
    }

    /**
     * 获取菜单列表
     * @return array
     * @author: fudaoji<fdj@kuryun.cn>
     */
    private function getMenuList(){
        $where = ['status' => 1, 'type' => 1];
        if($this->adminInfo['group_id'] != 1) {
            $adminGroup = model('AdminGroup')->getOne($this->adminInfo['group_id']);
            $where['id'] = ['in', explode(',', $adminGroup['rules'])];
        }
        $menuList = model('adminRule')->getAll([
            'filed' => 'id,pid,title,icon,href,target',
            'where' => $where,
            'order' => ['sort' => 'desc']
        ]);
        $menuList = $this->buildMenuChild(0, $menuList);
        return $menuList;
    }

    /**
     * 递归获取子菜单
     * @param $pid
     * @param $menuList
     * @return array
     * @author: fudaoji<fdj@kuryun.cn>
     */
    private function buildMenuChild($pid, $menuList){
        $treeList = [];
        foreach ($menuList as $v) {
            if ($pid == $v['pid']) {
                $node = $v;
                $child = $this->buildMenuChild($v['id'], $menuList);
                if (!empty($child)) {
                    $node['child'] = $child;
                }
                // todo 后续此处加上用户的权限判断
                $treeList[] = $node;
            }
        }
        return $treeList;
    }
}